﻿class Halde:
    class Henkel: # innere Klasse
        def __init__(self,s,x,pos):
            self.s = s # Schlüssel
            self.x = x # Wert
            self.pos = pos # Position im Feld h
            
    def __init__(self,maxLänge):
        self.maxLänge = maxLänge
        self.n = 0 # Länge der Halde
        self.h = [None]*(maxLänge+1)
         # Halde ist auf h[1] .. h[n] gespeichert. h[0] wird verschwendet.
         # Jedes h[i] ist ein Henkel.
         # Für i=1,...,n gilt:      h[i].pos == i
         # Für jeden Henkel H gilt: h[H.pos] == H
         
    def einfügen(self,x,s):
        if self.n>=self.maxLänge:
            raise RuntimeError("Feldüberlauf")
        self.n += 1
        self.h[self.n] = H = Halde.Henkel(s,x,self.n)
        self.zuklein(self.n)
        return H
    
    def entferneMin(self):
        if self.n<=0:
            raise RuntimeError("Halde ist leer")
        x = self.h[1].x
        self.n -= 1
        if self.n>0:
            self.vertausche(self.n + 1, 1)
            self.zugroß(1)
        return x
    
    def verkleinereSchlüssel(self,H,s_neu): # decreaseKey
        i = H.pos
        if s_neu > H.s: # == self.h[i].s
            raise RuntimeError("Wert ist nicht kleiner.")
        H.s = s_neu
        self.zuklein(i)
    
    def istleer(self):
        return self.n==0
    
    ##### Hilfsfunktionen: ######
    def zuklein(self, i):
        # h[i] ist möglicherweise kleiner als sein Vorgänger.
        if i==1: return
        Vorgänger = i//2
        if self.h[i].s < self.h[Vorgänger].s:
            self.vertausche(i,Vorgänger)
            self.zuklein(Vorgänger)
    
    def zugroß(self, i):
        # h[i] ist möglicherweise größer als seine Nachfolger.
        if 2*i > self.n:
            return # Es gibt keine Nachfolger.
        kleinsterNachfolger = 2*i
        if 2*i+1 <= self.n and self.h[2*i+1].s<self.h[2*i].s:
            kleinsterNachfolger = 2*i+1

        if self.h[i].s > self.h[kleinsterNachfolger].s:
            self.vertausche(i, kleinsterNachfolger)
            self.zugroß(kleinsterNachfolger)
    
    def vertausche(self, i1, i2):
        self.h[i1],self.h[i2] = self.h[i2],self.h[i1]
        self.h[i1].pos = i1
        self.h[i2].pos = i2
